DCMTK: dcmtk::log4cplus::spi::Filter Class Reference

DCMTK Version 3.6.9 OFFIS DICOM Toolkit

Loading...
Searching...
No Matches
Public Member Functions | Public Attributes | List of all members
dcmtk::log4cplus::spi::Filter Class Referenceabstract

Users should extend this class to implement customized logging event filtering. More...

Inheritance diagram for dcmtk::log4cplus::spi::Filter:

## Public Member Functions
void | appendFilter (FilterPtr filter)
| Appends `filter` to the end of this filter chain.
virtual FilterResult | decide (const InternalLoggingEvent &event) const =0
| If the decision is `DENY`, then the event will be dropped.

## Public Attributes
FilterPtr | next
| Points to the next filter in the filter chain.

## Detailed Description

Users should extend this class to implement customized logging event filtering.

Note that the `Logger` and `Appender` classes have built-in filtering rules. It is suggested that you first use and understand the built-in rules before rushing to write your own custom filters.

This abstract class assumes and also imposes that filters be organized in a linear chain. The `decide(LoggingEvent)` method of each filter is called sequentially, in the order of their addition to the chain.

If the value `DENY` is returned, then the log event is dropped immediately without consulting with the remaining filters.

If the value `NEUTRAL` is returned, then the next filter in the chain is consulted. If there are no more filters in the chain, then the log event is logged. Thus, in the presence of no filters, the default behaviour is to log all logging events.

If the value `ACCEPT` is returned, then the log event is logged without consulting the remaining filters.

The philosophy of log4cplus filters is largely inspired from the Linux ipchains.

## Member Function Documentation

## ◆ decide()

virtual FilterResult dcmtk::log4cplus::spi::Filter::decide | ( | const InternalLoggingEvent & | event | ) | const
| pure virtual

If the decision is `DENY`, then the event will be dropped.

If the decision is `NEUTRAL`, then the next filter, if any, will be invoked. If the decision is ACCEPT then the event will be logged without consulting with other filters in the chain.

Parameters

  event | The LoggingEvent to decide upon.

Returns
  The decision of the filter.

Implemented in dcmtk::log4cplus::spi::DenyAllFilter, dcmtk::log4cplus::spi::LogLevelMatchFilter, dcmtk::log4cplus::spi::LogLevelRangeFilter, and dcmtk::log4cplus::spi::StringMatchFilter.

The documentation for this class was generated from the following file:

- oflog/include/dcmtk/oflog/spi/filter.h

Generated on Wed Apr 30 2025 for DCMTK Version 3.6.9 by Doxygen 1.13.2